//A pair of glasses created by Bob Wind, rwind@genesee.freenet.org
//These are about one unit per 3 inches because they were originally
//created for my model of a certain pink bunny that carries a drum
//and wears sunglasses. Small bunnies need small sunglasses.

#declare ang1 = 10
#declare ang2 = 50
#declare ang3 = 20
#declare ang4 = 90
#declare ang5 = 10
#declare rad1 = 2
#declare rad2 = .15
#declare rad3 = 1
#declare rad4 = .1
#declare rad5 = 2.5

# declare half =
intersection {  
  union {
    union {  
      intersection {  
        union {  
          union {
            intersection { 
              intersection {
                cylinder { <0, 0, -.025>, <0, 0, .025>, rad1 } 
                box { <0, rad1-.5, -.1>, <rad1, rad1, .1> }
                rotate <0, 0, ang1>
              }
              box { <-rad1, 0, -.1>, <0.001, rad1, .1> }
              translate <0, rad2-rad1, 0>
            }
            cylinder { <0, 0, -.025>, <0, 0, .025>, rad2 } 
            rotate <0, 0, ang2>
            translate <0, rad3-rad2, 0>
          }
          intersection { 
            cylinder { <0, 0, -.025>, <0, 0, .025>, rad3 } 
            box { <-0.001, rad3-.6, -.1>, <rad3, rad3, .1> }
          }
          rotate <0, 0, ang3>
        }
        box { <-3, -3, -.1>, <0.001, rad3, .1> }
        translate <0, rad4-rad3, 0>
      }
      cylinder { <0, 0, -.025>, <0, 0, .025>, rad4 } 
      rotate <0, 0, ang4>
      translate <0, rad5-rad4, 0>
    }
    intersection { 
      cylinder { <0, 0, -.025>, <0, 0, .025>, rad5 } 
      box { <-0.001, rad5-.5, -.1>, <rad5, rad5, .1> }
    }  
    rotate <0, 0, ang5>
  }  
  box { <-3, -3, -.1>, <0, rad5, .1> }
  translate <0, .3-rad5, 0>
}
  
#declare whole = 
union {
  object { half }
  object { 
    half 
    rotate <0, 180 ,0> 
    translate <-.002, 0, 0>
  }
}

# declare half2 =
intersection {  
  merge {
    merge {  
      intersection {  
        merge {  
          merge {
            intersection { 
              intersection {
                cylinder { <0, 0, -.025>, <0, 0, .025>, rad1 } 
                box { <0, rad1-.5, -.1>, <rad1, rad1, .1> }
                rotate <0, 0, ang1>
              }
              box { <-rad1, 0, -.1>, <0.001, rad1, .1> }
              translate <0, rad2-rad1, 0>
            }
            cylinder { <0, 0, -.025>, <0, 0, .025>, rad2 } 
            rotate <0, 0, ang2>
            translate <0, rad3-rad2, 0>
          }
          intersection { 
            cylinder { <0, 0, -.025>, <0, 0, .025>, rad3 } 
            box { <-0.001, rad3-.6, -.1>, <rad3, rad3, .1> }
          }
          rotate <0, 0, ang3>
        }
        box { <-3, -3, -.1>, <0.001, rad3, .1> }
        translate <0, rad4-rad3, 0>
      }
      cylinder { <0, 0, -.025>, <0, 0, .025>, rad4 } 
      rotate <0, 0, ang4>
      translate <0, rad5-rad4, 0>
    }
    intersection { 
      cylinder { <0, 0, -.025>, <0, 0, .025>, rad5 } 
      box { <-0.001, rad5-.5, -.1>, <rad5, rad5, .1> }
    }  
    rotate <0, 0, ang5>
  }  
  box { <-3, -3, -.1>, <0, rad5, .1> }
  translate <0, .3-rad5, 0>
}
  
#declare whole2 = 
merge {
  object { half2 }
  object { 
    half2 
    rotate <0, 180 ,0> 
    translate <-.002, 0, 0>
  }
}

#declare lens =
union {
  difference {
    object { 
      whole
      }
    object { 
      whole
      scale <.85, .85, 1.01>
    }
    pigment { color Black }
  }
  intersection {
    difference {
      sphere { <0, 0, 1.93>, 2 }
      sphere { <0, 0, 1.95>, 2 }
      scale <1, .65, 1>
    }
    object { 
      whole2
      scale <.85, .85, 5>
    }
    texture {
      Glass3
//      pigment { color Brown filter 1 }
    }
  }
  bounded_by { box { <-.55, -.6, -.1>, <.55, .6, .05> } }
}

#declare bridge =
object {
  box { <-.1, -.05, -.025>, <.1, .05, .025> }
  pigment { color Black }
}

#declare bow =
object {
  box { <-.025, -.05, 0>, <.025, .05, 1.5> }
  pigment { color Black }
}

#declare glasses =
union {
  object { lens translate <-.55, 0, 0> }
  object { lens translate <.55, 0, 0> }
  object { bridge translate <0, .18, 0> }
  object { 
    bow 
    rotate <0, 10, 0>
    translate <-1.05, .18, -.025> 
  }
  object { 
    bow 
    rotate <0,-10, 0>
    translate <1.05, .18, -.025> 
  }
  bounded_by { box { <-1.1, -.6, -.1>, <1.1, .6, 1.5> } }
}
